<template>
  <div id="deviceAlarmConfig">
    <el-container>

      <el-main>
        <div style="margin-bottom: 10px">
          <el-button size="medium" icon="el-icon-back" type="text" @click="back">返回</el-button>
          <span style="margin-left: 20px; font-size: 18px">报警配置列表</span>
        </div>

        <el-button size="medium" icon="el-icon-search" style="margin-bottom: 15px" @click="search(searchFormData)">
          查询
        </el-button>
        <el-button size="medium" icon="el-icon-plus" @click="showAdd" style="margin-left: 0">新增</el-button>


        <div style="padding: 10px;background-color: white">
          <el-form :inline="true" :model="searchFormData" style="background-color: white;">
            <el-form-item label="报警名称">
              <el-input placeholder="报警名称" size="mini" v-model="searchFormData.alarmName"></el-input>
            </el-form-item>
            <el-form-item label="报警类型">
              <el-input placeholder="设备类型" size="mini" v-model="searchFormData.alarmType"></el-input>
            </el-form-item>

            <el-form-item label="变量id" style="margin-top: 6px" size="mini">
              <el-input placeholder="变量id" size="mini" v-model="searchFormData.variableId"></el-input>
            </el-form-item>
            <el-form-item label="判断条件" style="margin-top: 6px" size="mini">
              <el-input placeholder="判断条件" size="mini" v-model="searchFormData.condition"></el-input>
            </el-form-item>


            <el-dialog title="报警记录" :visible.sync="dialogFormVisible" style="width: 70% ; margin-left: 300px ;">
              <el-form label-position="left" :model="formData">

                <el-row style="margin-left: 14px">
                  <el-form-item label="报警名称" prop="alarmName">
                    <el-input v-model="formData.alarmName"></el-input>
                  </el-form-item>
                  <el-form-item label="报警类型" prop="alarmType">
                    <el-input v-model="formData.alarmType"></el-input>
                  </el-form-item>
                </el-row>

                <el-row style="margin-left: 30px">
                  <el-form-item label="变量Id" prop="variableId">
                    <el-input v-model="formData.variableId"></el-input>
                  </el-form-item>
                  <el-form-item label="判断条件" prop="condition">
                    <el-input v-model="formData.condition"></el-input>
                  </el-form-item>
                </el-row>
              </el-form>

              <el-row>
                <el-form-item label="运营商编号" prop="operatorNumber">
                  <el-select v-model="formData.operatorNumber" placeholder="运营商编号" style="width: 202px"
                             clearable>
                    <el-option :value="i.number" v-for="(i,index) in operators" :key="index"
                               :label="i.number"></el-option>
                  </el-select>
                </el-form-item>

                <el-form-item label="项目编号" prop="projectNumber">
                  <el-select v-model="formData.projectNumber" placeholder="项目编号" style="width: 202px"
                             :disabled="!formData.operatorNumber" clearable>
                    <el-option :value="i.number" v-for="(i,index) in projects" :key="index"
                               :label="i.number"></el-option>
                  </el-select>
                </el-form-item>
              </el-row>

              <el-row style="margin-left: 14px">
                <el-form-item label="网关编号" prop="gatewayNumber" style="margin-right: 22px">
                  <el-select v-model="formData.gatewayNumber" placeholder="网关编号" style="width: 202px"
                             :disabled="!formData.projectNumber" clearable>
                    <el-option :value="i.number" v-for="(i,index) in gateways" :key="index"
                               :label="i.number"></el-option>
                  </el-select>
                </el-form-item>
                <el-form-item label="设备sn" prop="sn">
                  <el-select v-model="formData.sn" placeholder="设备sn" style="width: 202px"
                             :disabled="!formData.gatewayNumber" clearable>
                    <el-option :value="i.sn" v-for="(i,index) in devices" :key="index"
                               :label="i.sn"></el-option>
                  </el-select>
                </el-form-item>
              </el-row>

              <div slot="footer" class="dialog-footer" style="text-align: center">
                <el-button @click="cancel()">取 消</el-button>
                <el-button type="primary" @click="addOrEditMehtond()">确 定</el-button>
              </div>
            </el-dialog>

          </el-form>


          <el-table :data="tableData">
            <el-table-column type="selection"></el-table-column>
            <el-table-column prop="sn" label="设备sn"></el-table-column>
            <el-table-column prop="alarmName" label="报警名称"></el-table-column>
            <el-table-column prop="alarmType" label="报警类型"></el-table-column>
            <el-table-column prop="variableId" label="变量Id"></el-table-column>
            <el-table-column prop="condition" label="判断条件"></el-table-column>

            <el-table-column label="操作">
              <template slot-scope="scope">
                <el-button type="text" size="medium" @click="showEdit(scope.row)">编辑</el-button>
                <el-button type="text" size="medium" @click="del(scope.row)" style="color: #c01920">删除</el-button>
              </template>
            </el-table-column>

          </el-table>


          <el-pagination
              style="margin-top: 15px;text-align: center"
              background
              layout="prev, pager, next"
              :page-size="pager.pageSize"
              :current-page="pager.pageIndex"
              :total="pager.itemCount"
              @current-change="handleCurrentChange"
          >
          </el-pagination>
        </div>
      </el-main>

    </el-container>
  </div>
</template>


<script>

export default {
  name: 'deviceAlarmConfig',
  data() {
    return {
      gateways: [],
      projects: [],
      operators: [],
      devices: [],

      api: {
        list: this.$api.deviceAlarmConfig.list,
        delete: this.$api.deviceAlarmConfig.delete,
        add: this.$api.deviceAlarmConfig.add,
        update: this.$api.deviceAlarmConfig.update,
      },

      value: true,

      addOrEdit: 1,

      dialogFormVisible: false,

      pager: {
        pageSize: 2,
        pageIndex: 1,
        itemCount: 0,
      },

      tableData:
          [{
            alarmName: '',
            alarmType: '',
            condition: '',
            variableId: '',
            sn: '',
          }],

      formData: {
        alarmName: '',
        alarmType: '',
        condition: '',
        variableId: '',

        sn: '',
        operatorNumber: '',
        projectNumber: '',
        gatewayNumber: ''
      },

      searchFormData:
          {
            alarmName: '',
            alarmType: '',
            condition: '',
            variableId: ''
          }
    }
  },

  created: function () {
    this.loadData();
    this.getOperator();
  },

  watch: {

    'searchFormData.operatorNumber'(oldValue, newValue) {

      console.log(oldValue)
      console.log(newValue)

      this.searchFormData.projectNumber = ''

      this.operatorProject = oldValue;

      console.log(this.operatorProject)

      this.getProjectNumber();
    },

    'searchFormData.projectNumber'(oldValue, newValue) {

      console.log(oldValue)
      console.log(newValue)

      this.searchFormData.gatewayNumber = ''

      this.projectGateway = oldValue;

      console.log(this.projectGateway)

      this.getGateway();
    },
    'searchFormData.gatewayNumber'(oldValue, newValue) {

      console.log(oldValue)
      console.log(newValue)

      this.searchFormData.sn = ''

      this.gatewayDevice = oldValue;

      console.log(this.gatewayDevice)

      this.getDevice();
    },


    'formData.operatorNumber'(oldValue, newValue) {

      console.log(oldValue)
      console.log(newValue)


      if (newValue == '') {
        this.operatorProject = oldValue;
      } else {
        this.operatorProject = oldValue;
        this.formData.projectNumber = ''
      }

      console.log(this.operatorProject)

      this.getProjectNumber();
    },

    'formData.projectNumber'(oldValue, newValue) {

      console.log(oldValue)
      console.log(newValue)


      if (newValue == '') {
        this.projectGateway = oldValue;
      } else {
        this.projectGateway = oldValue;
        this.formData.gatewayNumber = ''
      }

      console.log(this.projectGateway)

      this.getGateway();
    },

    'formData.gatewayNumber'(oldValue, newValue) {

      console.log(oldValue)
      console.log(newValue)

      if (newValue == '') {
        this.gatewayDevice = oldValue;
      } else {
        this.gatewayDevice = oldValue;
        this.formData.sn = ''
      }

      console.log(this.gatewayDevice)

      this.getDevice();
    }
  },

  methods: {
    //切换页码
    handleCurrentChange(index) {
      this.loadData(index)
    },

    getOperator() {
      const vm = this;
      vm.$http.get(vm.$api.operator.list).then((resp) => {
        vm.operators = resp.data.data.operators
      })
    },

    getProjectNumber() {
      const vm = this;
      vm.$http.get(vm.$api.project.list, {
        params: {
          operatorNumber: this.operatorProject,
        }
      }).then((resp) => {
        console.log(resp.data.data.projects)
        vm.projects = resp.data.data.projects
      })
    },

    getGateway() {
      const vm = this;
      vm.$http.get(vm.$api.gateway.list, {
        params: {
          projectNumber: this.projectGateway,
        }
      }).then((resp) => {
        console.log(resp.data.data.gateways)
        vm.gateways = resp.data.data.gateways
      })
    },

    getDevice() {
      const vm = this;
      vm.$http.get(vm.$api.device.list, {
        params: {
          gatewayNumber: this.gatewayDevice,
        }
      }).then((resp) => {
        console.log(resp.data.data.devices)
        vm.devices = resp.data.data.devices
      })
    },

    loadData(index) {
      const vm = this;
      vm.$http.get(vm.api.list, {
        params: {
          pageSize: 5,
          pageIndex: index ? index : 1,

          alarmName: this.searchFormData.alarmName,
          alarmType: this.searchFormData.alarmType,
          condition: this.searchFormData.condition,
          variableId: this.searchFormData.variableId,
        }
      })
          .then((response) => {
            console.log(response.data.data);

            vm.pager = response.data.data.pager

            vm.tableData = response.data.data.deviceAlarmConfigs;
          })
    },

    search() {
      this.loadData();
    },

    showAdd() {
      this.dialogFormVisible = true;

      this.formData.alarmName = '',
          this.formData.alarmType = '',
          this.formData.variableId = '',
          this.formData.condition = '',
          this.formData.operatorNumber = '',
          this.formData.projectNumber = '',
          this.formData.gatewayNumber = '',
          this.formData.sn = ''
    },

    showEdit(row) {
      console.log(row)

      this.dialogFormVisible = true;

      this.editRow = JSON.parse(JSON.stringify(row));
      this.formData = this.editRow


      this.addOrEdit = 2
    },


    addOrEditMehtond() {
      const vm = this;
      if (this.addOrEdit == 2) {
        vm.$http.get(vm.api.update, {
          params: {
            code: this.editRow.code,

            alarmName: this.formData.alarmName,
            alarmType: this.formData.alarmType,
            variableId: this.formData.variableId,
            configCondition: this.formData.condition,
            sn: this.formData.sn,

            operatorNumber: this.formData.operatorNumber,
            projectNumber: this.formData.projectNumber ,
            gatewayNumber: this.formData.gatewayNumber,

            deviceCode: this.editRow.deviceCode,
            operatorCode: this.editRow.operatorCode,
            projectCode: this.editRow.projectCode,
            gatewayCode: this.editRow.gatewayCode,
          }
        })
            .then((response) => {
              console.log(response)

              if (response.data.status == 200) {

                this.$message({
                  type: 'success',
                  showClose: true,
                  message: response.data.desc
                })
              }

              this.dialogFormVisible = false;

              this.loadData();

            })
            .catch(() => {
            });
      }

      if (this.addOrEdit == 1) {
        vm.$http.get(vm.api.add, {
          params: {
            alarmName: this.formData.alarmName,
            alarmType: this.formData.alarmType,
            variableId: this.formData.variableId,
            configCondition: this.formData.condition,
            operatorNumber: this.formData.operatorNumber,
            projectNumber: this.formData.projectNumber,
            gatewayNumber: this.formData.gatewayNumber,
            sn: this.formData.sn,
          }
        })
            .then((response) => {
              if (response.data.status == 200) {

                this.dialogFormVisible = false;

                this.$message({
                  type: 'success',
                  showClose: true,
                  message: response.data.desc
                })

                this.loadData();
              }
            })
      }
    },

    del(row) {
      const vm = this;
      this.$confirm('确认删除', '提示', {
        type: 'warning'
      }).then(() => {
        vm.$http.get(vm.api.delete, {
          params: {
            code: row.code,
          }
        })
            .then((response) => {
              console.log(response)
              if (response.data.status == 200) {
                this.$message({
                  type: 'success',
                  showClose: true,
                  message: response.data.desc
                })


              }
              this.loadData();
            })
      })
          .catch(() => {
            this.$message({
              type: 'info',
              showClose: true,
              message: '取消删除'
            })
          });
    },
    cancel() {
      this.$message({
        message: '操作取消',
        showClose: true,
        type: 'info'
      });
      this.formData.operatorNumber = '';
      this.formData.projectNumber = '';
      this.formData.gatewayNumber = '';
      this.formData.sn = '';

      this.dialogFormVisible = false;
    },

    back() {
      let vm = this;
      vm.$router.back()
    },

  }
}
</script>

<style scoped>
.el-form-item {
  margin-right: 10px;
  margin-left: 10px;
  margin-bottom: 10px;
  margin-top: 0px;
}

.el-row {
  margin-top: 15px;
}


</style>
